# class SS7Layer4 | Abstract SS7 layer 4 (application) protocol. More...
Full name | `TelEngine::SS7Layer4`
Definition | `#include <libs/ysig/yatesig.h>`
Inherits | TelEngine::SS7L3User [public ]
Inherited by | SS7BICC, SS7ISUP, SS7Management, SS7SCCP, SS7TUP, SS7Testing
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- virtual void destroyed ()
- virtual bool initialize (const NamedList* config)
- virtual void attach (SS7Layer3* network)
- inline SS7Layer3* network () const
- inline unsigned char sio () const
- inline unsigned char sif () const
- inline unsigned char ssf () const
- inline unsigned char prio () const
- inline unsigned char ni () const
- inline unsigned char getSIO (const NamedList& params) const

#### Public Static Methods

- static unsigned char getSIO (const NamedList& params, unsigned char sif, unsigned char prio, unsigned char ni)
- static inline unsigned char getSIO (const NamedList& params, unsigned char sif, unsigned char ssf)
- static inline unsigned char getSIO (const NamedList& params, unsigned char sio)

#### Protected Methods

- SS7Layer4 (unsigned char sio = SS7MSU::National, const NamedList* params = 0)
- inline int transmitMSU (const SS7MSU& msu, const SS7Label& label, int sls = -1)

#### Protected Members

- unsigned char m_sio

## Detailed Description

An interface to a Layer 4 (application) SS7 protocol

void destroyed () | ### destroyed

[virtual]

This method is called to clean up and destroy the object after the reference counter becomes zero

Reimplemented from SignallingComponent.

bool initialize (const NamedList* config) | ### initialize

[virtual]

Initialize the application layer, connect it to the SS7 router

Parameters:

config | Optional configuration parameters override

Returns: True if the application was initialized properly

Reimplemented from SignallingComponent.

void attach (SS7Layer3* network) | ### attach

[virtual]

Attach a SS7 network or router to this service. Detach itself from the old one if valid

Parameters:

network | Pointer to network or router to attach

Reimplemented from SS7L3User.

inline SS7Layer3* network () | ### network

[const]

Retrieve the SS7 network or router to which this service is attached

Returns: Pointer to the network or router this service is attached to

inline unsigned char sio () | ### sio

[const]

Get the default sending Service Information Octet for this protocol

Returns: SIO value

inline unsigned char sif () | ### sif

[const]

Get the Service Information Field (SS7 protocol number)

Returns: SIF value used in matching and sending MSUs

inline unsigned char ssf () | ### ssf

[const]

Get the default sending Service Switching Function bits for this protocol

Returns: Combined Priority and Network Indicator bits

inline unsigned char prio () | ### prio

[const]

Get the default sending Priority bits for this protocol

Returns: Priority bits

inline unsigned char ni () | ### ni

[const]

Get the default sending Network Indicator bits for this protocol

Returns: Network Indicator bits

unsigned char getSIO (const NamedList& params, unsigned char sif, unsigned char prio, unsigned char ni) | ### getSIO

[static]

Get a SIO value from a parameters list

Parameters:

params | Parameter list to retrieve "service", "priority" and "netindicator"
sif | Default Service Information Field to apply parameters to
prio | Default Priority Field to apply parameters to
ni | Default Network Indicator Field to apply parameters to

Returns: Adjusted SIO value

inline unsigned char getSIO (const NamedList& params, unsigned char sif, unsigned char ssf) | ### getSIO

[static]

Get a SIO value from a parameters list

Parameters:

params | Parameter list to retrieve "service", "priority" and "netindicator"
sif | Default Service Information Field to apply parameters to
ssf | Default Subservice Field to apply parameters to

Returns: Adjusted SIO value

inline unsigned char getSIO (const NamedList& params, unsigned char sio) | ### getSIO

[static]

Get a SIO value from a parameters list

Parameters:

params | Parameter list to retrieve "service", "priority" and "netindicator"
sio | Default SIO to apply parameters to

Returns: Adjusted SIO value

inline unsigned char getSIO (const NamedList& params) | ### getSIO

[const]

Get a SIO value from a parameters list

Parameters:

params | Parameter list to retrieve "service", "priority" and "netindicator"

Returns: Adjusted SIO value

SS7Layer4 (unsigned char sio = SS7MSU::National, const NamedList* params = 0) | ### SS7Layer4

[protected]

Constructor

Parameters:

sio | Default value of Service Information Octet
params | Optional parameters to alter the value of SIO

inline int transmitMSU (const SS7MSU& msu, const SS7Label& label, int sls = -1) | ### transmitMSU

[protected]

Ask the Layer 3 to push a Message Signal Unit down the protocol stack

Parameters:

msu | Message data, starting with Service Indicator Octet
label | Routing label of the MSU to use in routing
sls | Signalling Link Selection, negative to choose best

Returns: Link the message was successfully queued to, negative for error

unsigned char m_sio | ### m_sio

[protected]

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.